#include <iostream>
#include <vector>
using namespace std;

int main() {
	int n;
	cin >> n;
	vector<pair<int, int>> tacke(n);
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		tacke[i] = { x,y };
	}
	for (int i = 1; i <= n; i++) {
		int s = 0;
		for (int j = 0; j < i; j++) {
			int st = 0;
			bool cx = false, cy = false;
			int xa = tacke[j].first;
			int ya = tacke[j].second;
			for (int k = 0; k < i; k++) {
				int xi = tacke[k].first;
				int yi = tacke[k].second;
				if (xi == xa) cx = true;
				if (yi == ya) cy = true;
				st += abs(xi - xa) * abs(yi - ya);
			}
			if (cx && cy) {
				s = (st>s?st:s);
			}
		}
		cout << s << endl;
	}
}